#!/usr/bin/python


# Pygtk frontend for creating Freerdp launchers
# Author: Tony Brijeski
# Email: <tb6517@yahoo.com>
# Copyright 2013 GPLv2

import gtk
import os
import stat
import sys


class Freerdp(gtk.Window):

    def close(self,widget,event,data = None):
        self.hide()
        gtk.main_quit()
        return gtk.FALSE

    def prep(self,widget,option):
        print widget, option

        URLIP = self.urlentry.get_text()
        print URLIP
        if URLIP == "":
            self.hide()
            dialog = gtk.MessageDialog(self,gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "URL or IP Empty.\n\nField can't be empty")
            dialog.run()
            dialog.destroy()	
            self.show()
            return None
        
        USERNAME = self.userentry.get_text()
        if USERNAME == "":
            SUSERNAME = ""
        else:
            SUSERNAME = " -u " + USERNAME
        print SUSERNAME
        
        PASSWORD = self.passentry.get_text()
        if PASSWORD == "":
            SPASSWORD = ""
        else:
            SPASSWORD = " -p " + PASSWORD
        print SPASSWORD

        DOMAIN = self.domainentry.get_text()
        if DOMAIN == "":
            SDOMAIN = ""
        else:
            SDOMAIN = " -d " + DOMAIN
        print SDOMAIN
        
        FULLSCREEN = self.fullscreen.get_active()
        if FULLSCREEN == True:
            SFULLSCREEN = " -f "
        else:
            SFULLSCREEN = ""
        print SFULLSCREEN
        
        GEOMETRY = self.geomentry.get_text()
        if GEOMETRY == "":
            SGEOMETRY = ""
        else:
            SGEOMETRY = " -g " + GEOMETRY
        print SGEOMETRY
        
        BPP = self.bppentry.get_text()
        if BPP == "":
            SBPP = ""
        else:
            SBPP = " -a " + BPP
        print SBPP
        
        Freerdp = "xfreerdp " + SUSERNAME + SPASSWORD + SDOMAIN + SFULLSCREEN + SGEOMETRY + SBPP + " " + URLIP
        print Freerdp
        if option == "Run":
            os.system(Freerdp + " &")
            self.show()
            return None
        else:
            RFILENAME = os.environ['HOME'] + "/.xfreerdp-" + URLIP
            DFILENAME = os.environ['HOME'] + "/Desktop/xfreerdp-" + URLIP + ".desktop"
            print DFILENAME
            print RFILENAME
            RCONT = open(RFILENAME, 'w+')
            RCONT.write(Freerdp)
            RCONT.close()
            os.chmod(RFILENAME, stat.S_IRWXU)

            DFILECONTENTS = '''
[Desktop Entry]
Version=1.0
Type=Application
Name=RDP-%(URLIP)s
Comment=
Exec=%(RFILENAME)s
Icon=gnome-fs-network
Path=
Terminal=false
StartupNotify=false
''' % ({
            "URLIP" : URLIP,
            "RFILENAME" : RFILENAME
            })
            DCONT = open(DFILENAME, 'w+')
            DCONT.write(DFILECONTENTS)
            DCONT.close()
            os.chmod(DFILENAME, stat.S_IRWXU)
            self.hide()
            dialog = gtk.MessageDialog(self,gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "RDP-" + URLIP + "\n\nLauncher Created on your Desktop")
            dialog.run()
            dialog.destroy()
            self.show()	
            return None
        
    
    def __init__(self):
        super(Freerdp, self).__init__()
        
        self.set_title("RDP Launcher Creator")
        self.set_size_request(350, 350)
        self.set_position(gtk.WIN_POS_CENTER)
        
        win = gtk.Fixed()

        self.urllabel = gtk.Label("URL or IP:")
        self.urlentry = gtk.Entry()
        
        self.userlabel = gtk.Label("Username:")
        self.userentry = gtk.Entry()
        
        self.passlabel = gtk.Label("Password:")
        self.passentry = gtk.Entry()
        self.passentry.set_visibility(False)
        
        self.domainlabel = gtk.Label("Domain:")
        self.domainentry = gtk.Entry()
        
        self.fullscreen = gtk.CheckButton("Fullscreen")
        
        self.geomlabel = gtk.Label("Geometry:")
        self.geomentry = gtk.Entry()
        
        self.bpplabel = gtk.Label("Bits Per Pixel:")
        self.bppentry = gtk.Entry()
        
        self.savebutton = gtk.Button("Save")
        self.runbutton = gtk.Button("Connect")
        self.exitbutton = gtk.Button("Exit")

        self.exitbutton.connect("clicked", self.close, "Exit")
        self.savebutton.connect("clicked", self.prep, "Save")
        self.runbutton.connect("clicked", self.prep, "Run")

        win.put(self.urllabel, 50, 30)
        win.put(self.urlentry, 150, 25)
        
        win.put(self.userlabel, 50, 70)
        win.put(self.userentry, 150, 65)
        
        win.put(self.passlabel, 50, 110)
        win.put(self.passentry, 150, 105)
        
        win.put(self.domainlabel, 50, 150)
        win.put(self.domainentry, 150, 145)
        
        win.put(self.fullscreen, 50, 185)
        
        win.put(self.geomlabel, 50, 230)
        win.put(self.geomentry, 150, 225)
        
        win.put(self.bpplabel, 50, 270)
        win.put(self.bppentry, 150, 265)

        win.put(self.savebutton, 200, 310)
        win.put(self.runbutton, 250, 310)
        win.put(self.exitbutton, 50, 310)
                        
        self.add(win)
        
        self.connect("destroy", gtk.main_quit)
        self.show_all()

if __name__ == '__main__':
        
    Freerdp()
    gtk.main()
